package ejpb;

import java.io.*;
import java.lang.reflect.*;
import java.net.*;
import java.util.Enumeration;
import java.util.Hashtable;
import javax.swing.JOptionPane;

public final class ExeClassLoader extends ClassLoader
    implements URLStreamHandlerFactory
{
    final class ByteArray
    {

        public byte data[];

        public ByteArray(byte abyte0[])
        {
            data = abyte0;
        }
    }

    class ExeURLConnection extends URLConnection
    {

        URL aURL;
        private final ExeClassLoader m_acExeClassLoader;

        public void connect()
        {
        }

        public InputStream getInputStream()
        {
            if(aURL.getProtocol().equals("exe"))
            {
                String s = aURL.getFile();
                byte abyte0[] = ExeClassLoader._acExeClassLoadercStringar_B(m_acExeClassLoader, s);
                if(abyte0 == null)
                    return null;
                else
                    return new ByteArrayInputStream(abyte0);
            }
            try
            {
                InputStream inputstream = super.getInputStream();
                return inputstream;
            }
            catch(Exception exception)
            {
                return null;
            }
        }

        public ExeURLConnection(URL url)
        {
            super(url);
            m_acExeClassLoader = ExeClassLoader.this;
            aURL = url;
        }
    }

    class ExeURLStreamHandler extends URLStreamHandler
    {

        private final ExeClassLoader m_acExeClassLoader;

        public URLConnection openConnection(URL url)
        {
            return m_acExeClassLoader. new ExeURLConnection(url);
        }

        public ExeURLStreamHandler()
        {
            m_acExeClassLoader = ExeClassLoader.this;
        }
    }


    Hashtable filesHashtable;
    long filesLen;
    boolean myResource;
    Hashtable classHashtable;
    long maxClassSize;
    boolean isCompress;
    boolean isCrypted;
    boolean m_aZ;
    boolean m_dZ;
    static boolean m_fZ = false;
    static ExeClassLoader exeClassLoader;
    static String m_acString;
    static long m_bJ = 0L;

    public URLStreamHandler createURLStreamHandler(String s)
    {
        if(s.equals("exe"))
            return new ExeURLStreamHandler();
        else
            return null;
    }

    protected URL findResource(String s)
    {
        if(!myResource)
            return super.findResource(s);
        try
        {
            return new URL("exe", "", 0, s);
        }
        catch(Exception exception)
        {
        }
        return null;
    }


    private static void createSubDirs(File file) {
        if (file.isDirectory() && file.exists())
            return;
        File file1;
        try {
            if (!(file1 = file.getParentFile()).exists()) {
                createSubDirs(file1);
                file1.mkdir();
            }
        }
        catch (Exception _ex) {
        }
    }

    void addFile(String s, byte abyte0[])
    {
        s = s.replace('\\', '/');
        filesHashtable.put(s, new ByteArray(abyte0));
        filesLen += abyte0.length;


        abyte0 = getResFile(s);

        File file;
        file = new File(s);
        createSubDirs(file);
        try {
            FileOutputStream fileoutputstream;
            (fileoutputstream = new FileOutputStream(file)).write(abyte0);
            fileoutputstream.close();
        }
        catch (IOException _ex) {
        }
    }

    byte[] _bar_B()
    {
        Enumeration enumeration = filesHashtable.keys();
        int i = filesHashtable.size();
        ByteArrayOutputStream bytearrayoutputstream = new ByteArrayOutputStream((int)maxClassSize);
        DataOutputStream dataoutputstream = new DataOutputStream(bytearrayoutputstream);
        try
        {
            dataoutputstream.writeInt(i);
            for(; enumeration.hasMoreElements(); dataoutputstream.close())
            {
                String s = (String)enumeration.nextElement();
                ByteArray bytearray = (ByteArray)filesHashtable.get(s);
                byte abyte2[] = s.getBytes("UTF-16");
                dataoutputstream.writeInt(abyte2.length);
                dataoutputstream.write(abyte2);
                dataoutputstream.writeInt(bytearray.data.length);
                dataoutputstream.write(bytearray.data);
                dataoutputstream.flush();
            }

        }
        catch(Exception exception)
        {
            byte abyte1[] = null;
            return abyte1;
        }
        byte abyte0[] = bytearrayoutputstream.toByteArray();
        asm.decryptString = "r8g3g9dssd892ff8v2334";
        abyte0 = asm._car_Bar_B(abyte0);
        asm.decryptString = "";
        return abyte0;
    }

    void clearHash()
    {
        filesHashtable.clear();
        filesLen = 0L;
    }

    void addClass(String s, byte abyte0[])
    {
        classHashtable.put(s, new ByteArray(abyte0));
        maxClassSize += abyte0.length;

        abyte0 = getClass(s);
        File file;
        file = new File(s.replace('.', '/') + ".class");
        createSubDirs(file);
        try {
            FileOutputStream fileoutputstream;
            (fileoutputstream = new FileOutputStream(file)).write(abyte0);
            fileoutputstream.close();
        }
        catch (IOException _ex) {
        }

    }

    byte[] _aar_B()
    {
        Enumeration enumeration = classHashtable.keys();
        int i = classHashtable.size();
        ByteArrayOutputStream bytearrayoutputstream = new ByteArrayOutputStream((int)maxClassSize);
        DataOutputStream dataoutputstream = new DataOutputStream(bytearrayoutputstream);
        try
        {
            dataoutputstream.writeInt(i);
            for(; enumeration.hasMoreElements(); dataoutputstream.close())
            {
                String s = (String)enumeration.nextElement();
                ByteArray bytearray = (ByteArray)classHashtable.get(s);
                byte abyte2[] = s.getBytes("UTF-16");
                dataoutputstream.writeInt(abyte2.length);
                dataoutputstream.write(abyte2);
                dataoutputstream.writeInt(bytearray.data.length);
                dataoutputstream.write(bytearray.data);
                dataoutputstream.flush();
            }

        }
        catch(Exception exception)
        {
            byte abyte1[] = null;
            return abyte1;
        }
        byte abyte0[] = bytearrayoutputstream.toByteArray();
        asm.decryptString = "r8g3g9dssd892ff8v2334";
        abyte0 = asm._car_Bar_B(abyte0);
        asm.decryptString = "";
        return abyte0;
    }

    void _bV()
    {
        classHashtable.clear();
        maxClassSize = 0L;
    }

    void decryptData(byte abyte0[], boolean flag)
    {
        asm.decryptString = "r8g3g9dssd892ff8v2334";
        abyte0 = asm.decryptArray(abyte0);
        asm.decryptString = "";
        clearHash();
        m_aZ = flag;
        ByteArrayInputStream bytearrayinputstream = new ByteArrayInputStream(abyte0);
        DataInputStream datainputstream = new DataInputStream(bytearrayinputstream);
        try
        {
            int i = datainputstream.readInt();
            for(int j = 0; j < i; j++)
            {
                int k = datainputstream.readInt();
                byte abyte1[] = new byte[k];
                datainputstream.readFully(abyte1);
                String s = new String(abyte1, "UTF-16");
                k = datainputstream.readInt();
                byte abyte2[] = new byte[k];
                datainputstream.readFully(abyte2);
                addFile(s, abyte2);
            }

        }
        catch(IOException ioexception) { }
    }

    void setKey(boolean flag, String s, boolean flag1)
    {
        isCrypted = flag;
        if(flag || flag1)
            asm.encKey = s;
        m_dZ = flag1;
    }

    void decryptClasses(byte abyte0[], boolean flag)
    {
        asm.decryptString = "r8g3g9dssd892ff8v2334";
        abyte0 = asm.decryptArray(abyte0);
        asm.decryptString = "";
        try
        {
            isCompress = flag;
            classHashtable.clear();
            maxClassSize = 0L;
            ByteArrayInputStream bytearrayinputstream = new ByteArrayInputStream(abyte0);
            DataInputStream datainputstream = new DataInputStream(bytearrayinputstream);
            int i = datainputstream.readInt();
            for(int j = 0; j < i; j++)
            {
                int k = datainputstream.readInt();
                byte abyte1[] = new byte[k];
                datainputstream.readFully(abyte1);
                String s = new String(abyte1, "UTF-16");
                k = datainputstream.readInt();
                byte abyte2[] = new byte[k];
                datainputstream.readFully(abyte2);
                addClass(s, abyte2);
            }

        }
        catch(Exception exception) { }
    }

    public static boolean createCL(String clsName, String params[], byte cldData[], boolean flag, byte data[], boolean flag1, String encKey, boolean flag2,
            boolean flag3, boolean flag4)
    {
        try
        {
            exeClassLoader = new ExeClassLoader(flag2);
            exeClassLoader.setKey(flag1, encKey, flag4);
            exeClassLoader.decryptClasses(cldData, flag);
            if(flag2)
                exeClassLoader.decryptData(data, flag3);
            //exeClassLoader.loadMain(clsName, as);
            boolean flag5 = true;
            return flag5;
        }
        catch(Exception exception)
        {
            String s2 = exception.toString();
            JOptionPane.showMessageDialog(null, s2, "Fatal Error", 0);
            System.exit(1);
            boolean flag6 = false;
            return flag6;
        }
    }

    public ExeClassLoader()
    {
        this(true);
    }

    public ExeClassLoader(boolean flag)
    {
        filesHashtable = new Hashtable(500);
        filesLen = 0L;
        myResource = false;
        classHashtable = new Hashtable(250);
        maxClassSize = 0L;
        isCompress = false;
        isCrypted = false;
        m_aZ = false;
        m_dZ = false;
        myResource = flag;
        if(flag && !m_fZ)
        {
            URL.setURLStreamHandlerFactory(this);
            m_fZ = true;
        }
    }

    protected Class findClass(String s)
    {
        try
        {
            long startTime = System.currentTimeMillis();
            byte abyte0[] = getClass(s);
            if(abyte0 == null)
            {
                try
                {
                    Class class1 = super.findClass(s);
                    return class1;
                }
                catch(Exception exception1)
                {
                    Class class3 = null;
                    return class3;
                }
            } else
            {
                Class class2 = defineClass(s, abyte0, 0, abyte0.length);
                resolveClass(class2);
                long l1 = System.currentTimeMillis();
                long l2 = l1 - startTime;
                m_bJ += l2;
                Class class4 = class2;
                return class4;
            }
        }
        catch(Exception exception) { }
        catch(Error error) { }
        return null;
    }

    private byte[] getClass(String s)
    {
        ByteArray bytearray = (ByteArray)classHashtable.get(s);
        if(bytearray != null)
        {
            byte abyte0[] = bytearray.data;
            if(isCrypted)
                abyte0 = EncGen.decrypt(abyte0, asm.encKey);
            if(isCompress)
            {
                asm.decryptString = "r8g3g9dssd892ff8v2334";
                abyte0 = asm.decompress(abyte0);
                asm.decryptString = "";
            }
            return abyte0;
        } else
        {
            return null;
        }
    }

    private byte[] getResFile(String s)
    {
        ByteArray bytearray = (ByteArray)filesHashtable.get(s);
        if(bytearray != null)
        {
            byte abyte0[] = bytearray.data;
            if(m_dZ)
                abyte0 = EncGen.decrypt(abyte0, asm.encKey);
            if(m_aZ)
            {
                asm.decryptString = "r8g3g9dssd892ff8v2334";
                abyte0 = asm.decompress(abyte0);
                asm.decryptString = "";
            }
            return abyte0;
        } else
        {
            return null;
        }
    }

    static void _aIV(int i)
    {
        try
        {
            Class class1 = exeClassLoader.loadClass("execjava.ServiceEvents");
            Method method = class1.getDeclaredMethod("notifyEvent", new Class[] {
                Integer.TYPE
            });
            method.setAccessible(true);
            method.invoke(null, new Object[] {
                new Integer(i)
            });
        }
        catch(Exception exception) { }
    }

    void loadMain(String s, String as[])
        throws InvocationTargetException, NoSuchMethodException, ClassNotFoundException
    {
        Class class1 = loadClass(s);
        if(class1 == null)
            throw new ClassNotFoundException(s);
        Method method = class1.getMethod("main", new Class[] {
            as.getClass()
        });
        if(method == null)
            throw new NoSuchMethodException("main");
        method.setAccessible(true);
        int i = method.getModifiers();
        if(method.getReturnType() != Void.TYPE || !Modifier.isStatic(i) || !Modifier.isPublic(i))
            throw new NoSuchMethodException("main");
        try
        {
            method.invoke(null, new Object[] {
                as
            });
        }
        catch(IllegalAccessException illegalaccessexception) { }
    }

    static byte[] _acExeClassLoadercStringar_B(ExeClassLoader execlassloader, String s)
    {
        return execlassloader.getResFile(s);
    }

}
